unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    Button3: TButton;
    Timer1: TTimer;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    Lienzo : TCanvas;
    X,Y    : integer;
    pinta  : boolean;
    procedure LinH(a,b,L,col : integer);
    procedure LinV(a,b,L,col : integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.LinH(a,b,L,col : integer);
var
  k : integer;
begin
  for k := 0 to L-1 do
    Lienzo.Pixels[a+k,b] := col;
end;

procedure TForm1.LinV(a,b,L,col : integer);
var
  k : integer;
begin
  for k := 0 to L-1 do
    Lienzo.Pixels[a,b+k] := col;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Lienzo := Image1.Canvas;
  X := 200; Y := 200;
  pinta := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Image1.Canvas.Pixels[100,100] := $FF0000;

  Image1.Canvas.Pixels[99,100] := $FF0000;
  Image1.Canvas.Pixels[101,100] := $FF0000;
  Image1.Canvas.Pixels[100,99] := $FF0000;

  Image1.Canvas.Pixels[100,101] := $FF0000;
  Image1.Canvas.Pixels[100,102] := $FF0000;
  Image1.Canvas.Pixels[100,103] := $FF0000;
  Image1.Canvas.Pixels[100,104] := $FF0000;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  k : integer;
begin
  for k := 0 to 99 do
    Lienzo.Pixels[100+k,150] := $00FF00;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  LinH(200,200,50, $0000FF);
  LinV(250,200,50, clYellow);
  LinV(200,200,50, $0000FF);
  LinH(200,250,50, clBlack);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Button4.Caption = 'ON'
  then begin
    Timer1.Enabled  := true;
    Button4.Caption := 'OFF'
  end
  else begin
    Timer1.Enabled  := false;
    Button4.Caption := 'ON'
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if pinta then begin

  LinH(X,Y,50, clRed);
  LinV(X+50,Y,50, clGreen);
  LinV(X,Y,50, clBlue);
  LinH(X,Y+50,50, clBlack);
  Timer1.Interval := 50;

 end
 else begin

  LinH(X,Y,50, clWhite);
  LinV(X+50,Y,50, clWhite);
  LinV(X,Y,50, clWhite);
  LinH(X,Y+50,50, clWhite);
  Timer1.Interval := 1;

  X := X+1;
 end;
 pinta := not pinta;
end;

end.
